#version 330 core

//Input der Vertices
in vec3 position;
in vec2 uv;
in vec3 normal;

//Output, wird an den Fragment uebergeben, dh. interpolation pro Fragment
out vec2 fUVs;
out vec3 position_wspc;
out vec3 normal_cspc;
out vec3 viewdir_cspc;

uniform mat4 viewMatrix;
uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;

//uniform mat4 normalMatrix;

void main(){

	//Outputposition des Vertex (outPos), im Clipspace: modelviewprojection Matrix * position
	mat4 MVP= projectionMatrix * viewMatrix * modelMatrix;
	gl_Position= MVP * vec4(position,1);

	//Position des Vertex (P), im Worldspace: modelmatrix * position
	position_wspc= vec3(viewMatrix * modelMatrix * vec4(position,1.0));

	//Vektor der vom Vertex auf die Kamera zeigt (viewMatrix), im Cameraspace
	// im Cameraspace ist die Kamera im Ausgangspunkt
	vec3 vPosition_cspc= vec3(viewMatrix * modelMatrix * vec4(position,1.0));

	viewdir_cspc= vec3(0,0,0) - vPosition_cspc;

	//Normale des Vertex (N), in Cameraspace
	//normal_cspc= vec3(viewMatrix * modelMatrix * vec4(normal,0.0)); //Nur richtig wenn die Modelmatrix das model nicht skaliert, sonst die inverse transponierte Matrix.
	// diese berechnung sollte nicht im Shader stattfinden
	normal_cspc= vec3(transpose(inverse(viewMatrix * modelMatrix))* vec4(normal,0.0)); //Nur richtig wenn die Modelmatrix das model nicht skaliert, sonst die inverse transponierte Matrix.

	//UV des Vertex 
	fUVs= uv;
}