#version 330 core

//Input der Vertices
in vec3 position;
in vec2 uv;
in vec3 normal;
in vec4 tangent;

//Output, wird an den Fragment uebergeben, dh. interpolation pro Fragment
out vec2 fUVs;
out vec3 position_wspc;
out vec3 normal_cspc;
out vec3 viewdir_cspc;
out vec4 tangent_cspc;

//out vec3 view_dir_tan;
//out mat3 TBN;

uniform mat4 viewMatrix;
uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;

//uniform mat4 normalMatrix;

void main(){
	
	//Outputposition des Vertex (outPos), im Clipspace: modelviewprojection Matrix * position
	mat4 MVP= projectionMatrix * viewMatrix * modelMatrix;

	//Position des Vertex (P), im Worldspace: modelmatrix * position
	position_wspc= (modelMatrix * vec4(position,1)).xyz;

	//Vektor der vom Vertex auf die Kamera zeigt (viewMatrix), im Cameraspace
	// im Cameraspace ist die Kamera im Ausgangspunkt
	vec3 vPosition_cspc= (viewMatrix * modelMatrix * vec4(position,1)).xyz;

	viewdir_cspc= vec3(0,0,0) - vPosition_cspc;

	//Normale des Vertex (N), in Cameraspace
	//normal_cspc= (viewMatrix * modelMatrix * vec4(normal,0)).xyz; //Nur richtig wenn die Modelmatrix das model nicht skaliert, sonst die inverse transponierte Matrix.
	// diese berechnung sollte nicht im Shader stattfinden
	normal_cspc= normalize (( viewMatrix * modelMatrix * vec4(normal,0)).xyz); //Nur richtig wenn die Modelmatrix das model nicht skaliert, sonst die inverse transponierte Matrix.

	gl_Position= MVP * vec4(position,1);
	//UV des Vertex 
	fUVs= uv;

	// Fuer NormalMapping
	tangent_cspc = viewMatrix * modelMatrix * tangent;

	//vec3 bitangent = cross(normal, tangent.xyz) * tangent.w;
	//vec3 bitangent_cspc = normalize((viewMatrix * modelMatrix * vec4(bitangent,0) ).xyz);
	

	//TBN = transpose(mat3(tangent_cspc,bitangent_cspc,normal_cspc));
	

}