#version 330 core

in vec2 st;
uniform sampler2D tex;
uniform sampler2D tex2;
uniform vec2 end;
uniform vec2 direction;
uniform vec2 resolution;
out vec4 frag_color;

vec2 gaussFilter[15] = vec2[]( 
	vec2(-7.0,	0.0088),
	vec2(-6.0,	0.0182),
	vec2(-5.0,	0.0336),
	vec2(-4.0,	0.0553),
	vec2(-3.0,	0.0816),
	vec2(-2.0,	0.1078),
	vec2(-1.0,	0.1273),
	vec2(0.0,	0.1346),
	vec2(1.0,	0.1273),
	vec2(2.0,	0.1078),
	vec2(3.0,	0.0816),
	vec2(4.0,	0.0553),
	vec2(5.0,	0.0336),
	vec2(6.0,	0.0182),
	vec2(7.0,	0.0088)
);

void main(){

	vec3 color = vec3(0.0);
	
	// Gaussfilter wird angewendet
	for( int i = 0; i < 15; i++ )
	{
		vec2 gauss = gaussFilter[i];
		color += texture2D( tex2, st + vec2(gauss.x/resolution.x*3*direction.x, gauss.x/resolution.y*3*direction.y)).rgb * gauss.y;
	}

	vec3 color2;

	// Nach vertikal GaussPass wird zusammengerechnet.
	if(direction.y == 0.0){
		color2 = vec3(0.0);
	}else{
		if(end.x == 1.0){
			color2 = texture2D(tex,st).xyz;
		}
	}

	frag_color = vec4(color2+color,1.0);
}